# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class UserCreateRequest(Model):
    """Request object to create a new user.

    All required parameters must be populated in order to send to Azure.

    :param first_name: Required. The user's first name
    :type first_name: str
    :param last_name: Required. The user's last name
    :type last_name: str
    :param email: Required. User's email
    :type email: str
    :param application_role_code: Required. The user's role. Must be one of
     the following:
     - ApplicationUser
     - SaasAdmin (Requester must be Saas)
     - Sales (Requester must be at least Sales)
     - Sentry (Requester must be at least Sentry). Possible values include:
     'Invalid', 'SaasAdmin', 'AccountAdmin', 'ApplicationUser', 'Technician',
     'User', 'SystemProcess', 'Sentry', 'Sales', 'CorporationAdmin',
     'CorporationUser', 'CorporationNone'
    :type application_role_code: str or ~smartdiagnostics_sdk.models.enum
    :param corporations: The corporations the user belongs to. Saas users
     should not belong to any corporations
    :type corporations:
     list[~smartdiagnostics_sdk.models.UserRequestCorporationChild]
    :param locations: The locations the user belongs to. Saas users should not
     belong to any locations
    :type locations:
     list[~smartdiagnostics_sdk.models.UserRequestLocationChild]
    """

    _validation = {
        'first_name': {'required': True, 'max_length': 100, 'min_length': 1},
        'last_name': {'required': True, 'max_length': 100, 'min_length': 1},
        'email': {'required': True, 'max_length': 256},
        'application_role_code': {'required': True},
    }

    _attribute_map = {
        'first_name': {'key': 'FirstName', 'type': 'str'},
        'last_name': {'key': 'LastName', 'type': 'str'},
        'email': {'key': 'Email', 'type': 'str'},
        'application_role_code': {'key': 'ApplicationRoleCode', 'type': 'str'},
        'corporations': {'key': 'Corporations', 'type': '[UserRequestCorporationChild]'},
        'locations': {'key': 'Locations', 'type': '[UserRequestLocationChild]'},
    }

    def __init__(self, *, first_name: str, last_name: str, email: str, application_role_code, corporations=None, locations=None, **kwargs) -> None:
        super(UserCreateRequest, self).__init__(**kwargs)
        self.first_name = first_name
        self.last_name = last_name
        self.email = email
        self.application_role_code = application_role_code
        self.corporations = corporations
        self.locations = locations
